#ifndef KINECTWRITER_H
#define KINECTWRITER_H

#include "kinect.h"
#include "myfreenectdevice.h"
#include <sstream>
#include <sys/timeb.h>
#include <sys/time.h>
#include <time.h>



class KinectWriter : public Kinect
{
public:
    KinectWriter(const std::string, const bool, const int ndevice = 0);
    KinectWriter(const std::string, const std::string, const bool, const int ndevice = 0);
    KinectWriter(){};
    void write();
    virtual ~KinectWriter();
    virtual bool getData();
private:
    unsigned long initial_tick_count;
    bool view;
    MyFreenectDevice* device;
    Freenect::Freenect freenect;
    inline unsigned long getTimestamp();
    std::string directory;
    bool twoK;
    std::stringstream nameRGB;
    std::stringstream nameDepth;
};

#endif // KINECTWRITER_H
