#include <iostream>
#include <sstream>
#include <fstream>
#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "kinectwriter.h"
#include "kinectreader.h"
#include "pthread.h"

std::string sequence = "";
std::string sequence_2 = "";
std::string dir1 = "";
std::string dir2 = "";
bool k1 = false;
bool out = false;
bool out2k = false;
bool in = false;
bool view = false;
int ndevice = 0;
pthread_mutex_t mtx1, mtx2;


void read_console_parameters(int argc, char *argv[]) {


    if(argc < 2) {
        std::cout <<  "Usage: " << argv[0] << "-h" << std::endl;
        exit(-1);
    }

    for(int i = 1; i < argc; ++i ) {

        if(strcmp(argv[i], "-vid") == 0) {
            in = true;
            sequence = std::string(argv[i+1]);
            i++;
        } else if (strcmp(argv[i], "-out2k") == 0) {
            out2k = true;
            sequence = std::string(argv[i+1]);
            sequence_2 = std::string(argv[i+2]);
            dir1 = std::string(argv[i+3]);
            dir2 = std::string(argv[i+4]);
            i+=4;
        } else if (strcmp(argv[i], "-out") == 0) {
            out = true;
            sequence = std::string(argv[i+1]);
            ndevice = atoi(argv[i+2]);
            i+=2;
        } else if (strcmp(argv[i], "-view") == 0) {
            view = true;
        } else if (strcmp(argv[i], "-h") == 0) {
            std::cout << "Usage: " << argv[0] << " -vid directory_name: to read a video" << std::endl;
            std::cout << "\t" << argv[0] << " -out filename (without extension): to write a video" << std::endl;
            std::cout << "\t" << argv[0] << " -view: to visualize the video" << std::endl;
        } else {
            std::cout <<  "Usage: " << argv[0] << "-h" << std::endl;
            exit(-1);
        }

    }
}


void *rec_1(void *obj) {
    KinectWriter *kinectObject = (KinectWriter*) obj;
    bool contr = true;
    while(kinectObject->getData()) {
        pthread_mutex_lock(&mtx1);
        if(!k1) {
            kinectObject->write();
            k1 = true;
            pthread_mutex_unlock(&mtx1);
        } else {
            pthread_mutex_unlock(&mtx1);
        }
        cv::imshow("RGB#1", kinectObject->frame);
        cv::imshow("DEPTH#1", kinectObject->depth);
        if( cv::waitKey( 30 ) >= 0 ) contr = false;
    }
}

void *rec_2(void *obj) {
    KinectWriter *kinectObject = (KinectWriter*) obj;
    bool contr = true;
    while(contr && kinectObject->getData()) {
        pthread_mutex_lock(&mtx2);
        if(k1) {
            kinectObject->write();
            k1 = false;
            pthread_mutex_unlock(&mtx2);
        } else {
            pthread_mutex_unlock(&mtx2);
        }
        cv::imshow("RGB#2", kinectObject->frame);
        cv::imshow("DEPTH#2", kinectObject->depth);
        if( cv::waitKey( 30 ) >= 0 ) contr = false;
    }
}

int main( int argc, char *argv[]) {

    read_console_parameters(argc, argv);


    Kinect *kinectObject;
    Kinect *kinectObject2;
    pthread_t thread1, thread2;

    if(out || view) {
        kinectObject = new KinectWriter(sequence, view, ndevice);
    } else if (in) {
        kinectObject = new KinectReader(sequence);
    } else if (out2k) {
        kinectObject = new KinectWriter(sequence, dir1, view, 0);
        kinectObject2 = new KinectWriter(sequence_2, dir2, view, 1);
    }

    if(out2k) {
        pthread_create( &thread1, NULL, &rec_1, (void*) kinectObject);
        pthread_create( &thread2, NULL, &rec_2, (void*) kinectObject);
    }

    bool contr = true;
    while(contr && kinectObject->getData()) {

        if(out || view || in) {
            cv::imshow("RGB", kinectObject->frame);
            cv::imshow("DEPTH", kinectObject->depth);
        }

        if( cv::waitKey( 30 ) >= 0 ) contr = false;
    }

    if(out2k) {
        pthread_join( thread1, NULL);
        pthread_join( thread2, NULL);
    }

    if(kinectObject)
        delete kinectObject;
    if(kinectObject2)
        delete kinectObject2;

    return 0;
}
